
/*
 * Copyright (C) 2011 Technische Universitaet Muenchen
 * This file is part of the Sierpi project. For conditions of distribution and
 * use, please see the copyright notice in the file 'copyright.txt' at the root
 * directory of this package and the copyright notice at http://www5.in.tum.de/sierpi
 *
 * This file was automatically generated by the sierpinski code generator
 */


void K_e_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

    if (structure_lifo_in.getNextData())
    {
    TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
    TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
        depth++;
        K_o_forward(vx2, vy2, vx0, vy0, mx, my, depth);
        K_o_forward(vx1, vy1, vx2, vy2, mx, my, depth);
        return;
    }
	kernelClass.elementAction(vx0, vy0, vx1, vy1, vx2, vy2, depth);
}

void K_o_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

    if (structure_lifo_in.getNextData())
    {
    TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
    TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
        depth++;
        K_e_forward(vx1, vy1, vx2, vy2, mx, my, depth);
        K_e_forward(vx2, vy2, vx0, vy0, mx, my, depth);
        return;
    }
	kernelClass.elementAction(vx0, vy0, vx1, vy1, vx2, vy2, depth);
}

void K_e_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

    if (structure_lifo_in.getNextData())
    {
    TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
    TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
        depth++;
        K_o_backward(vx1, vy1, vx2, vy2, mx, my, depth);
        K_o_backward(vx2, vy2, vx0, vy0, mx, my, depth);
        return;
    }
	kernelClass.elementAction(vx0, vy0, vx1, vy1, vx2, vy2, depth);
}

void K_o_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

    if (structure_lifo_in.getNextData())
    {
    TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
    TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
        depth++;
        K_e_backward(vx2, vy2, vx0, vy0, mx, my, depth);
        K_e_backward(vx1, vy1, vx2, vy2, mx, my, depth);
        return;
    }
	kernelClass.elementAction(vx0, vy0, vx1, vy1, vx2, vy2, depth);
}
